/*
 * ToGrammarRightRGGlushkov.h
 *
 *  Created on: 11. 1. 2014
 *      Author: Tomas Pecka
 */

#ifndef TO_GRAMMAR_RIGHT_RG_GLUSHKOV_H_
#define TO_GRAMMAR_RIGHT_RG_GLUSHKOV_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/RightRG.h>

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

namespace regexp {

namespace convert {

/**
 * Converts regular expression to right regular grammar using Glushkov algorithm.
 * Source: None yet.
 */
class ToGrammarRightRGGlushkov : public regexp::VisitableRegExpBase::const_visitor_type
{
public:
    /**
     * Performs conversion.
     * @param regexp original regular expression
     * @return right regular grammar equivalent to source regexp.
     */
    static grammar::Grammar convert(const regexp::RegExp& regexp);

    static grammar::RightRG convert(const regexp::FormalRegExp& regexp);
    static grammar::RightRG convert(const regexp::UnboundedRegExp& regexp);

private:
    void Visit(void*, const regexp::FormalRegExp& regexp) const;
    void Visit(void*, const regexp::UnboundedRegExp& regexp) const;

    static const ToGrammarRightRGGlushkov TO_GRAMMAR_RIGHT_RG_GLUSHKOV;
};

} /* namespace convert */

} /* namespace regexp */

#endif /* TO_GRAMMAR_RIGHT_RG_GLUSHKOV_H_ */
